library timeline.snapshot.main;
import 'package:crypto/crypto.dart';

import 'dart:convert' show HtmlEscape;
import 'dart:html';
import 'dart:js' as jsR;
import 'package:intl/intl.dart';
import '../lib/src/js_convert.dart' as js;
import 'dart:async';
import 'dart:convert';
import '../lib/ext3mimicry.dart';
import '../wrike/wrike.dart';
import '../wrike/src/entity/entity.dart';
import 'lib/snapshot/snapshot.dart';

part 'w__calendars_impl.dart';
part 'w__folders_impl.dart';

class w_EnvImp extends w_Env {
    int modals = 0;
    int FOLDER = 0;
    int ACCOUNT = 0;
}

class ExtImp extends ExtInterface {
    bool enableNestedListenerRemoval = false;
    bool useShims = false;
    bool enableFx = true;
    bool isGecko = false;
    bool isOpera = false;
    bool isIE = false;
    bool isIE6 = false;
    bool isIE7 = false;
    bool isIE8 = false;
    bool isIE9 = false;
    bool isIE9m = false;
    bool isIE10 = false;
    bool isIE10p = false;
    bool isIE11 = false;
    bool isStrict = false;
    bool isWebKit = true;
    bool isSafari = false;
    bool isSafari2 = false;
    bool isGecko2 = false;
    bool isMobile = (new RegExp(
            r"Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini",
            caseSensitive: false)).hasMatch(window.navigator.userAgent);

    bool isSecure = true;

    /**
   * True if the detected platform is Linux.
   */
    bool isLinux = false;

    /**
   * True if the detected platform is Mac OS.
   */
    bool isMac = false;

    /**
   * True if the detected platform is Adobe Air.
   */
    bool isAir = false;

    /**
   * True if the detected platform is Windows.
   */
    bool isWindows = true;

    bool isBorderBox = false;
    bool isForcedBorderBox = false;
}

class wrike_BusImp extends Ext_util_Observable implements wrike_Bus {
    String id;
}

class w_AccountsImpl extends w_Accounts {
    int get defaultAccountId => 0;
    bool get isMultiAccount => false;

    static Account account;

    w_AccountsImpl() {
    }

    Account getById(dynamic id) {
        return account;
    }

    @override
    getTreeNodePrefix(acc) {
        var accId, rec;
        if (acc is Ext_data_Record) {
            rec = acc;
            accId = rec.id/* .data["id"]*/;
        } else {
            accId = acc;
            rec = this.getById(acc);
        }
        if (rec != null) {
            return (true /*js.isTrue(rec.data["isDefault"])*/ ? '' : 'acc${accId}_');
        } else {
            return (accId < 0 ? '' : 'acc${accId}_');
        }
    }
}

class w_user_BetaFlagsImpl extends w_user_BetaFlags {
    bool customFields = false;
    bool abSearchSelector = false;
}


class WImpl extends WInterface {
    bool hasAccountRightOrFree(wrike_permission_Right permission, int accountId) {
        return false;
    }

    bool hasAccountRight(wrike_permission_Right permission, [int accountId, Map recordOverrides]) {
        return false;
    }

    void loadFolderRights(int folderId, arg1) {

    }
}

void initComponents(String snapshotId) {
    String host = window.location.host;
    String protocol = window.location.protocol;
    String link = '${protocol}//${host}/timeline/index.html?id=${snapshotId}';

    wrike_snapshot_HideableTip permalinkTip = new wrike_snapshot_HideableTip()
            ..cls = 'permalink-tip'
            ..closeOnOutClick = true
            ..items = [new Ext_BoxComponent()
                        ..cls = 'x-form-label'
                        ..html = 'Link to this snapshot'
                        ..constructor(), new Ext_form_TextField()
                        ..value = link
                        ..readOnly = true
                        ..selectOnFocus = true
                        ..constructor()]
            ..constructor();

    Ext_Button linkButton = new Ext_Button()
            ..cls = 'button header-link-button'
            ..renderTo = Ext_get('header')
            ..handler = (e) {
                permalinkTip.showBy(e.sender.el, 'tl-bl?', [0, 0]);
            }
            ..constructor();
}

void initSOYEnv() {
    jsR.context["soy"]["helpers"] = new jsR.JsObject.jsify({
        "Ext.util.Format.date": new jsR.JsFunction.withThis((that, DateTime dt, String format) {
            DateFormat formatter = new DateFormat('MM/dd/y');
            return formatter.format(dt);
        }),
        "Ext.util.Format.formatDuration": new jsR.JsFunction.withThis((that, dur) {
            return wrike_date.formatDuration(dur);
        })
    });
    jsR.context[r"$wrike"] = new jsR.JsObject.jsify({
        'l10n': new jsR.JsFunction.withThis((that, section, value, [List params]) {
            return wrike_l10n(section, value, params);
        })
    });
    //Ext_util_Format.date
}

void showErrorMessage(String msg) {
    wrike_tip_ModalTip errorModal = new wrike_tip_ModalTip()
            ..closable = false
            ..title = 'Error'
            ..html = msg
            ..cls = 'error-tip'
            ..constructor();

    errorModal.showCenter();
}

void showRegistrationForm() {

    RegExp emailRe =
            new RegExp(r"([!#$%&'*+/=?^`{}|~a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]{2,})");

    Storage localStorage = window.localStorage;

    wrike_snapshot_HideableTip errorTip = new wrike_snapshot_HideableTip()
            ..closeOnOutClick = true
            ..cls = 'email-error-tip'
            ..html = 'Please enter a valid email address'
            ..constructor();

    Ext_form_TextField emailField = new Ext_form_TextField()
            ..injectTo = '.registration-form-controls'
            ..emptyText = 'your@email.com'
            ..constructor();

    emailField.validator = (v) {
        String value = emailField.el.dom.value;
        String email = emailRe.stringMatch(value);

        // because quick tips not implemented yet - just show tip
        if (email == null && email != emailField.emptyText) {
            errorTip.showBy(emailField.el, 'tr-tl?', [-10, 0]);
            return 'Please enter a valid email address';
        } else {
            errorTip.hide();
            return true;
        }
    };

    Ext_Container registrationForm = new Ext_Container()
            ..id = 'registration-form'
            ..cls = 'registration-form'
            ..layout = 'inject'
            ..renderTo = Ext_getBody()
            ..html = """
            <div class="registration-form-controls">
                <h2 class="registaration-form-title">Got a project?</h2>
                <p class="registration-form-text">Plan it <strong>today</strong></p>
            </div>
            <div class="registration-form-result">
                <h2 class="registaration-form-title">
                    Thank you! 
                    <img class="logo-img" src="img/wrikelogo.png" width="25" height="16" />
                </h2>
                <p class="registration-form-text">Please check your inbox <br />and follow to the link</p>
            </div>
            """
            ..items = [emailField, new Ext_Button()
                        ..injectTo = '.registration-form-controls'
                        ..cls = 'button button-send'
                        ..handler = (e) {
                            String value = emailField.el.dom.value;
                            String email = emailRe.stringMatch(value);
                            if (email != null && email != emailField.emptyText) {
                                localStorage['snapshot.register.email'] = email;

                                post('/email_only_registration.htm', {
                                    "email": email,
                                    "license_id": 49,
                                    "agreement": true,
                                    "short_form": true,
                                    "first_name": "",
                                    "last_name": "",
                                    "external": true,
                                    "locale": "en",
                                    "isAjax": true,
                                    "email_only_form": true,
                                    "go_confirmation": 0
                                }, null).then((result) {
                                    Ext_get('registration-form').addClass('sended');
                                });
                            }
                        }
                        ..constructor(), new Ext_Button()
                        ..injectTo = '.registration-form-result'
                        ..cls = 'button button-resend'
                        ..text = 'Resend email'
                        ..handler = (e) {
                            Ext_get('registration-form').removeClass('sended');
                        }
                        ..constructor(), new Ext_Button()
                        ..cls = 'button button-close'
                        ..handler = (e) {
                            localStorage['snapshot.register.collapsed'] = 'true';
                            Ext_get('registration-form').addClass('collapsed');
                        }
                        ..constructor(), new Ext_Button()
                        ..cls = 'button button-logo'
                        ..handler = (e) {
                            localStorage.remove('snapshot.register.collapsed');
                            Ext_get('registration-form').removeClass('collapsed');
                        }
                        ..constructor()]
            ..constructor();

    String isCollapsed = localStorage['snapshot.register.collapsed'];
    if (isCollapsed == 'true') {
        registrationForm.addClass('collapsed');
    }

    String lastEmail = localStorage['snapshot.register.email'];
    if (lastEmail != null) {
        //emailField.setValue(lastEmail);
        registrationForm.addClass('sended');
    }

    registrationForm.show();
}

void initAnalytics([String uid = '']) {
    String params =
            "?redirected=yes&pageUri=" +
            Uri.encodeQueryComponent(window.location.pathname + window.location.search) +
            "&utm_source=wrikers&utm_medium=timeline_shared&utm_campaign=" +
            uid;

    IFrameElement tracking = new IFrameElement()
            ..src = "/analyticstracking.htm" + params
            ..style.display = 'none';

    document.body.append(tracking);
}

void initLogoImg([int accountId = 0]) {
    String defaultLogoImg = "img/logo.png";

    ImageElement logoImageEl = document.getElementById('logo-img');
    logoImageEl.addEventListener('error', (e) {
        logoImageEl.src = defaultLogoImg;
    });

    String logoImageSrc = defaultLogoImg;

    if (accountId != null && accountId > 0) {
        String hash =
                CryptoUtils.bytesToHex((new MD5()..add("A${accountId}".codeUnits)).close()).toUpperCase();
        logoImageSrc =
                "/avatars/${hash.substring(28, 30)}/${hash.substring(30, 32)}/account_${accountId}_workspace.png";
    }

    logoImageEl.src = logoImageSrc;
}

class w_UserImpl extends w_User {
    String locale = 'en';
    String dateFormat = 'dd/MM/yyyy';
    String uid = '_uid_';
    String defaultSortOrder = '10';

    bool viewCriticalPath = false;
    bool needGoogleAuth = true;
    bool showGoogleAgreement = true;

    List excludedWeekDays = [0, 6];
}

class w_ContactsImpl extends Ext_data_Store implements w_Contacts {
    static final rt =
            new Ext_data_RecordInfo(wrike_record_Contact.create, wrike_record_Contact.fieldsGlobal);
    Ext_data_JsonReader reader =
            new Ext_data_JsonReader()..constructor(new Ext_data_JsonReaderMeta()
                    ..idProperty = "uid"
                    ..root = "data", rt);

    @override
    Contact getById(dynamic uid) {
        wrike_record_Contact user = super.getById(uid);
        if (user != null) {
            return new Contact(
                    uid: uid,
                    fullName: user.get('firstName') + ' ' + user.get('lastName'));
        } else {
            return null;
        }

    }

}

Future<HttpRequest> _request(String method, String url, data, Map<String, String> headers) {
    url = wrike_api.actionsPrefix + url;
    if (headers == null) {
        headers = {};
    }
    headers["Wrike-Client-Id"] = wrike_api.WRIKE_CLIENT_ID_RANDOM;

    return HttpRequest.request(
            url,
            method: method,
            requestHeaders: headers,
            sendData: data).then((result) {
        //print("$url->${result.responseText}");
        return result;
    });
}

Future<HttpRequest> post(String url, Map<String, String> params, Map<String, String> headers,
        {body}) {
    if (headers == null) {
        headers = new Map();
    }
    if (body == null) {
        body = wrike_api.encodeParams(params);
        headers["Content-type"] = "application/x-www-form-urlencoded";
    } else {
        var data = wrike_api.encodeParams(params);
        if (data.length > 0) {
            url += "?" + data;
        }
        print(url);
    }
    return _request("POST", url, body, headers);
}

Future<HttpRequest> get(String url, Map<String, String> params, Map<String, String> headers) {
    if (headers == null) {
        headers = new Map();
    }
    var data = wrike_api.encodeParams(params);
    if (data.length > 0) {
        url += "?" + data;
    }

    return _request("GET", url, '', headers);
}

main() {
    initSOYEnv();
    var sanitizer = const HtmlEscape();
      
    wrike_l10n = (String section, String value, [List params]) => value;
    Ext = new ExtImp();
    wrike_bus = new wrike_BusImp()..constructor();
    w_env = new w_EnvImp();
    w_accounts = new w_AccountsImpl();
    w = new WImpl();
    w_user_betaFlags = new w_user_BetaFlagsImpl();
    w_user = new w_UserImpl();

    /*w_contacts = new w_ContactsImpl()
        ..accountStore= this.accounts
        ..broadcast=  new wrike_Broadcast('data.contacts', wrike_bus)
      ..constructor();*/
    var rtFolder =
            new Ext_data_RecordInfo(wrike_record_Folder.create, wrike_record_Folder.fieldsGlobal);
    w_folders = new w_FoldersImpl()
// explicitly create reader
            ..reader = (new Ext_data_ArrayReader()..constructor(
                    new Ext_data_JsonReaderMeta()..idProperty = "id",
                    rtFolder))
            /*{
       idIndex: 0 // id for each record will be the first element
     },rt  // recordType
     * */
            ..recordType = rtFolder
            ..constructor();
    var id = Uri.parse(window.location.href).queryParameters["id"];

    if (id == null) {
        showErrorMessage("The snapshot has been deleted");
        return false;
    }

    initComponents(id);

    get('/ui/get_workspace_snapshot', {
        "snapshotId": id
    }, null).then((result) {
        Map value = JSON.decode(result.responseText);

        // fix firstDayOfWeek - in JS weekday starts from 0, in Dart from 1
        if (value['firstDayOfWeek'] == 0) {
            value['firstDayOfWeek'] = 7;
        }

        bool userLoggedIn = result.getResponseHeader('userLoggedIn') == "true";

        String authorUid = value['authorUid'] != null ? value['authorUid'] : '';
        initAnalytics(authorUid);

        Ext_get('header-title-name').update(sanitizer.convert(value['name']));

        initLogoImg(value['accountId']);

        DateTime generationDate = Date.parseDate(value['generationDate'], "Y-m-d H:i:s");
        Ext_get('header-title-date').update(new DateFormat("MMM dd y").format(generationDate));

        wrike_firstWeekDay = value['firstDayOfWeek'];
        w_contacts = new w_ContactsImpl()
                ..recordType = w_ContactsImpl.rt
                ..constructor();

        var contacts = value["contacts"] as List;
        (w_contacts as Ext_data_Store).suspendEvents();
        (w_contacts as Ext_data_Store).add(
                contacts.map((contact) => wrike_record_Contact.create(contact, contact["uid"])).toList());
        (w_contacts as Ext_data_Store).resumeEvents();

        w_calendars = new w_CalendarsImpl()
                ..constructor()
                ..loadData({
                    'accountExclusions': [],
                    'daysOff': {
                        w_env.ACCOUNT: {
                            'accountDaysOff': value["daysOff"],
                            'usersDaysOff': {}
                        }
                    },
                    'existsNextPortion': false,
                    'userExclusions': {}
                }, null);

        w_AccountsImpl.account = Account.parseJSON({
            'email': "_",
            'id': 0,
            'external': false,
            'verified': true,
            'firstDayOfWeek': value['firstDayOfWeek'],
            'daysOff': value['daysOff']
        });

        var genRootFolder = value["rootFolder"];
        var rootFolder = {
            "fid": "root",
            "text": "root",
            "children": [genRootFolder]
        };

        w_folders.loadTree(rootFolder, -1, w_accounts.defaultAccountId);
        w_env.FOLDER = genRootFolder["fid"];

        List tasks = value["tasks"];
        Map folderDates = value["folderDates"];
        tasks.forEach((task) => task["task"] = true);

        Ext_getBody().addClass('loaded');

        if (userLoggedIn == false) {
            showRegistrationForm();
        }

        Ext_Element timelineWrapper = Ext_get('timeline-wrapper');

        wspace_timeline2_ViewSnapshot snapshotView =
                new wspace_timeline2_ViewSnapshot(tasks, folderDates, generationDate)
                ..autoWidth = true
                ..height = timelineWrapper.getHeight(true)
                ..bus = wrike_bus
                ..renderTo = Ext_get('timeline-wrapper')
                ..constructor();

        snapshotView.autoHeight = true;

        snapshotView.doLoad({
            "id": w_env.FOLDER,
            "context": "timeline2",
            "showDescendants": false,
            "sortOrder": "10",
            "filters": new wrike_FilterCollection(),
            "streamNoauto": false,
            "streamFilterName": "all-my",
            "toggleFilter": false,
            "showFolderInfo": false,
            "streamFolderId": null,
            "accountId": w_env.ACCOUNT,
            "parent": null,
            "globalSearch": false
        });

    }).catchError((e) {
        window.console.log(e);
        showErrorMessage("The snapshot has been deleted");
    });
}
